﻿/*
	This file is part of Filters - Grafikus szurok
	Copyright (C) 2008, Istvan Neuwirth <pitta2@gmail.com>
		
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;

namespace Filters
{
    class SaveJPEG : ISaveImage
    {
        public void SaveImage(string fileName, Bitmap bitmap)
        {
            try
            {
                frmSaveJPEG form = new frmSaveJPEG();
                DialogResult dR = form.ShowDialog();
                if (dR == DialogResult.OK)
                {
                    ImageCodecInfo jpegEncoder = null;
                    ImageCodecInfo[] imageCodecs = ImageCodecInfo.GetImageEncoders();
                    foreach (ImageCodecInfo iCI in imageCodecs)
                    {
                        if (iCI.MimeType == "image/jpeg")
                        {
                            jpegEncoder = iCI;
                            break;
                        }
                    }

                    EncoderParameters encoderParams = new EncoderParameters(1);
                    encoderParams.Param[0] = new EncoderParameter(Encoder.Quality, form.Quality);

                    bitmap.Save(fileName, jpegEncoder, encoderParams);
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Hiba a kép mentésénél!\nMessage: " + e.Message + "\nSource: " + e.Source, "Hiba", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}
